package core.service;

import core.dao.BaseDao1;
import core.dao.BaseDao2;
import db.AbstractModel;
import db.DBAction;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

/**
 * Created by reborn on 2017/7/28.
 */
@Service
public class BaseService {

    protected static Logger log=LogManager.getLogger();
    @Resource
    protected BaseDao1 baseDao1;

    @Resource
    protected BaseDao2 baseDao2;

    @Transactional("transactionManager1")
    public<T extends AbstractModel> T curd(DBAction action, T command) throws DataAccessException {
        switch (action) {
            case C:
                baseDao1.save(command);break;
            case U:
                baseDao1.update(command);break;
            case R:
                AbstractModel model=baseDao1.get(command.getClass(), command.primaryKey());
                if(model!=null){
                    return model.cast();
                }
            case D:
                baseDao1.delete(command);break;
            default:
                throw new RuntimeException("非法操作：" + action);
        }
        return null;

    }

    public <T extends  AbstractModel> List find(T command, int firstResult, int maxResults){
        return baseDao1.findByCriteria(command.getCriteria(),firstResult,maxResults);
    }



}
