package db;

import java.io.Serializable;

public class JsonResult<T> extends ToJSON{

    private T data;

    private JsonResult.type type;

    private DBAction action;

    public JsonResult(T data, JsonResult.type type, DBAction action) {
        this.data = data;
        this.type = type;
        this.action = action;
    }

    public enum type implements Serializable {
        success("成功"),
        fail("失败") ;
        private String desc;

        type(String desc) {
            this.desc = desc;
        }

        public String getDesc() {
            return desc;
        }
    }

    public T getData() {
        return data;
    }

    public JsonResult.type getType() {
        return type;
    }

    public DBAction getAction() {
        return action;
    }
}
