package web.controller;

import db.DBAction;
import db.model.DataModel;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import web.service.DataService;

import javax.annotation.Resource;
import java.util.EnumSet;

@Controller
@RequestMapping("/data")
public class DataController extends BaseController<DataModel> {

    @Resource
    private DataService dataService;

    @RequestMapping("start/{size}")
    public void start(@PathVariable Integer size){
       stop();
       dataService.start(size);
    }

    @RequestMapping("stop")
    public void stop(){
        dataService.stop();
    }

    @Override
    public boolean checkAction(DBAction action) {
        return !EnumSet.of(DBAction.D).contains(action);
    }
}
